<?php
/*
Plugin Name: Android Appmaker
Plugin Script: appmaker.php
Description: Erstelle Android-Apps auf Grundlage deiner Seite.
Version: 4.0
License: GPL
Author: appmaker.merq.org
Author URI: https://appmaker.merq.org

=== RELEASE NOTES ===
2012-09-14 - v1.0 - first version
2012-09-19 - v1.1 - output bug fixed
2012-09-19 - v1.2 - other bugs fixed
2013-09-25 - v2.0 - Appmaker pro added
2013-09-27 - v2.6 - comment fix
2013-09-28 - v2.7 - youtube fix
2013-09-28 - v2.8 - image / link fix
2013-09-29 - v2.9 - file_get_contents replaced
2013-09-30 - v3.0 - subcategories added
2013-09-30 - v3.1 - subcategories fix
2013-09-30 - v3.3 - subcategories fix / xml fix
2013-10-01 - v3.4 - time zone fix
2013-10-02 - v3.5 - rename functions
2016-09-15 - v3.6 - Appmaker WordPress
2016-09-16 - v3.7 - Pro version - Push messaging
2016-09-16 - v3.8 - Firefox fixed
2019-12-29 - v3.9 - Bugfixes
2021-05-02 - v4.0 - Update for Gutenberg editor, WordPress 5.X
*/

/* 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
Online: http://www.gnu.org/licenses/gpl.txt
*/

if ($_GET['rss'] == "1") {
require( '../../../wp-load.php' );
if ($_GET['p'] == get_option('wp_merq_appmaker')) {
//FEEDAUSGABE
$numposts = get_option('wp_merq_appmaker_anzahl'); // number of posts in feed
$posts = query_posts('showposts='.$numposts.'&cat=');
$more = 1;

header('Content-Type: '.feed_content_type('rss-http').'; charset='.get_option('blog_charset'), true);
echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?'.'>';
?>

<rss version="2.0"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:atom="http://www.w3.org/2005/Atom"
	xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
	xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
	<?php do_action('rss2_ns'); ?>
>
<channel>
	<title><?php bloginfo_rss('name'); wp_title_rss(); ?></title>
	<atom:link href="<?php self_link(); ?>" rel="self" type="application/rss+xml" />
	<link><?php bloginfo_rss('url') ?></link>
	<description><?php bloginfo_rss("description") ?></description>
	<lastBuildDate><?php echo mysql2date('D, d M Y H:i:s +0000', get_lastpostmodified('GMT'), false); ?></lastBuildDate>
	<?php the_generator( 'rss2' ); ?>
	<language><?php echo get_option('rss_language'); ?></language>
	<sy:updatePeriod><?php echo apply_filters( 'rss_update_period', 'hourly' ); ?></sy:updatePeriod>
	<sy:updateFrequency><?php echo apply_filters( 'rss_update_frequency', '1' ); ?></sy:updateFrequency>
	<?php do_action('rss2_head'); ?>
	<?php while( have_posts()) : the_post(); ?>

	<item>
		<title><?php the_title_rss(); ?></title>
		<link><?php the_permalink_rss(); ?></link>
		<comments><?php comments_link(); ?></comments>
		<pubDate><?php echo mysql2date('D, d M Y H:i:s +0000', get_post_time('Y-m-d H:i:s', false), false); ?></pubDate>
		<dc:creator><?php the_author(); ?></dc:creator>
<?php the_category_rss(); ?>
		<guid isPermaLink="false"><?php the_guid(); ?></guid>
<?php if (get_option('rss_use_excerpt')) : ?>

		<description><![CDATA[<?php the_content() ?>]]></description>
<?php else : ?>

		<description><![CDATA[<?php the_content() ?>]]></description>
	<?php if ( strlen( $post->post_content ) > 0 ) : ?>

		<content:encoded><![CDATA[<?php the_content() ?>]]></content:encoded>
	<?php else : ?>

		<content:encoded><![CDATA[<?php the_excerpt_rss() ?>]]></content:encoded>
	<?php endif; ?>
<?php endif; ?>

		<wfw:commentRss><?php echo get_post_comments_feed_link(); ?></wfw:commentRss>
		<slash:comments><?php echo get_comments_number(); ?></slash:comments>
<?php rss_enclosure(); ?>
<?php do_action('rss2_item'); ?>

	</item>
	<?php endwhile; ?>

</channel>
</rss>
<?php
//FEEDAUSGABE ENDE
}
exit;
}


add_action('admin_menu', 'my_plugin_menu');

function my_plugin_menu() {
	add_options_page('Einstellungen', 'Appmaker.merq.org', 'manage_options', 'appmaker', 'my_plugin_options');
}

function my_plugin_options() {


    //must check that the user has the required capability 
    if (!current_user_can('manage_options'))
    {
      wp_die( __('You do not have sufficient permissions to access this page.') );
    }


    if( $_POST['anzahl'] != '' ) {
	update_option('wp_merq_appmaker_anzahl',$_POST['anzahl']);


?>
<div class="updated"><p><strong><?php _e('Anzahl der Beiträge gespeichert.', 'menu-start' ); ?></strong></p></div>
<?php
}

if( $_POST['pushurl'] != '' ) {
update_option('wp_merq_appmaker_pushurl',$_POST['pushurl']);
?>
<div class="updated"><p><strong><?php _e('Push-URL gespeichert.', 'menu-start' ); ?></strong></p></div>
<?php
}
	
	if( $_POST['pushurl'] == '0' ) {
update_option('wp_merq_appmaker_pushurl','');
?>
<div class="updated"><p><strong><?php _e('Push-URL gelöscht.', 'menu-start' ); ?></strong></p></div>
<?php
}

if (get_option('wp_merq_appmaker_anzahl') == "") {
update_option('wp_merq_appmaker_anzahl',"20");
}	
	
if (get_option('wp_merq_appmaker') == "") {

$pool = "qwertzupasdfghkyxcvbnm23456789WERTZUPLKJHGFDSAYXCVBNM";
srand ((double)microtime()*1000000);
for($index = 0; $index < 6; $index++) { $pass_word .= substr($pool,(rand()%(strlen ($pool))), 1); }

update_option('wp_merq_appmaker',$pass_word);

}
?>
<div class="wrap">
<h2>Einstellungen: Appmaker</h2>
<h3><a href="https://appmaker.merq.org" target="_blank">Appmaker.merq.org</a></h3>
Mithilfe dieses Plugins kannst du deine eigene Android App erstellen. Die App enthält u.a. die letzten Artikel deiner Seite.<br /><br />
1. Registriere dich kostenlos bei <a href="https://appmaker.merq.org" target="_blank">Appmaker.merq.org</a>.<br />
2. Erstelle auf der Seite eine neue App und gebe die hier genannte URL (s.u.) in das RSS-Feed - Feld ein.<br />
3. Die Android App ist fertig. Du kannst auf deiner Seite noch einen Link zur App setzen!<br />
4. Bei Bedarf kannst du den Pro-Tarif buchen und von weiteren Vorteilen profitieren! Und lasse dir eine iOS App auf Anfrage erstellen.<br /><br />
URL zum RSS-Feed: <b><?php echo plugin_dir_url(__FILE__)."appmaker.php?rss=1&p=".get_option('wp_merq_appmaker'); ?><br/><br/></b>
<form name="form1" method="post" action="">
<p>Push-URL (nur Pro-Tarif, 0 für Löschen): 
<input type="text" name="pushurl" value="<?php echo get_option('wp_merq_appmaker_pushurl'); ?>">
</p>


<p>Anzahl Beiträge, welche in der App angezeigt werden sollen: 
<input type="text" name="anzahl" value="<?php echo get_option('wp_merq_appmaker_anzahl'); ?>" size="5">
</p>
<i>Hinweis: Änderungen werden in der App nach zirka 30 Minuten sichtbar!</i>

<br>
<p class="submit"><input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" /></p>
</form>

</div>
<?php
}

if (get_option('wp_merq_appmaker_pushurl') != "") {
wp_enqueue_script(
    'appmaker-merq-js',
    '/wp-content/plugins/android-appmaker/appmaker-merq.js?url='.get_option('wp_merq_appmaker_pushurl'),
    array( 'wp-edit-post', 'wp-plugins', 'wp-i18n', 'wp-element' ),
    '4.0'
);
}